{{- if and .Values.deploy.restapi }}
apiVersion: "apps/v1"
kind: "Deployment"
metadata:
  annotations:
    meta.helm.sh/release-name: {{ .Release.Name }}
    meta.helm.sh/release-namespace: {{ .Release.Namespace }}
    {{- with .Values.restapi.annotations }}
    {{ toYaml . | nindent 4 }}
    {{- end }}
  labels:
    app.kubernetes.io/managed-by: Helm
    app: {{ .Values.restapi.name }}
    version: "{{ .Chart.Version }}"
    group:  stackgres.io
  name: {{ .Values.restapi.name }}
  namespace: {{ .Release.Namespace }}
spec:
  replicas: {{ if or (eq "true" (include "stackgres.operator.resetCerts" .)) (eq "true" (include "stackgres.operator.upgradeCrds" .)) }}0{{ else }}1{{ end }}
  selector:
    matchLabels:
      app: {{ .Values.restapi.name }}
      group:  stackgres.io
  template:
    metadata:
      labels:
        app: {{ .Values.restapi.name }}
        group:  stackgres.io
    spec:
      {{- with .Values.restapi.affinity}}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end}}
      serviceAccountName: {{ .Values.restapi.name }}
      {{- if .Values.serviceAccount.create }}
      {{- if .Values.serviceAccount.repoCredentials }}
      imagePullSecrets:
      {{- range .Values.serviceAccount.repoCredentials }}
        - name: {{ . }}
      {{- end }}
      {{- end }}
      {{- end }}
      {{- with .Values.restapi.nodeSelector}}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      securityContext:
        {{- if or (not (.Capabilities.APIVersions.Has "project.openshift.io/v1")) .Values.developer.disableArbitraryUser }}
        runAsNonRoot: true
        {{- if .Values.restapi.image.tag | hasSuffix "-jvm" }}
        fsGroup: 185
        {{- else }}
        fsGroup: 1000
        {{- end }}
        {{- end }}
      containers:
      - name: {{ .Values.restapi.name }}
        image: "{{ include "restapi-image" . }}"
        imagePullPolicy: {{ .Values.restapi.image.pullPolicy }}
        securityContext:
          {{- if or (not (.Capabilities.APIVersions.Has "project.openshift.io/v1")) .Values.developer.disableArbitraryUser }}
          runAsNonRoot: true
          {{- if .Values.restapi.image.tag | hasSuffix "-jvm" }}
          runAsUser: 185
          runAsGroup: 185
          {{- else }}
          runAsUser: 1000
          runAsGroup: 1000
          {{- end }}
          {{- end }}
        env:
          - name: RESTAPI_NAMESPACE
            valueFrom:
              fieldRef:
                apiVersion: v1
                fieldPath: metadata.namespace
          {{- if .Values.developer.logLevel }}
          - name: RESTAPI_LOG_LEVEL
            value: "{{ .Values.developer.logLevel }}"
          {{- end }}
          {{- if .Values.developer.showStackTraces }}
          - name: RESTAPI_SHOW_STACK_TRACES
            value: "{{ .Values.developer.showStackTraces }}"
          {{- end }}
          {{- if .Values.developer.extraOpts }}
          - name: APP_OPTS
            value: '{{ range .Values.developer.extraOpts }}{{ . }} {{ end }}'
          {{- end }}
          {{- if .Values.developer.enableJvmDebug }}
          - name: DEBUG_RESTAPI
            value: "{{ .Values.developer.enableJvmDebug }}"
          {{- end }}
          {{- if .Values.developer.enableJvmDebugSuspend }}
          - name: DEBUG_RESTAPI_SUSPEND
            value: "{{ .Values.developer.enableJvmDebugSuspend }}"
          {{- end }}
          - name: RESTAPI_IP
            valueFrom:
              fieldRef:
                fieldPath: status.podIP
          {{- if and .Values.grafana.url .Values.grafana.token .Values.grafana.webHost }}
          - name: GRAFANA_EMBEDDED
            value: "true"
          {{- end }}
          - name: AUTHENTICATION_SECRET_NAME
            value: "{{ .Values.authentication.secretRef.name | default .Values.restapi.name }}"
          {{- if and (.Capabilities.APIVersions.Has "project.openshift.io/v1") (not .Values.developer.disableArbitraryUser) }}
          - name: USE_ARBITRARY_USER
            value: "true"
          {{- end }}
          {{- if .Values.extensions.cache.enabled }}
          - name: EXTENSIONS_REPOSITORY_URLS
            value: "{{ range $index, $element := .Values.extensions.repositoryUrls }}{{ if $index }},{{ end }}{{ $element := regexReplaceAll "([?&])proxyUrl=[^&]+[&]" $element "${1}" }}{{ $element := regexReplaceAll "([?&])proxyUrl=[^&]+$" $element "" }}{{ $element }}{{ if $element | contains "?" }}&{{ else }}?{{ end }}proxyUrl=http%3A%2F%2F{{ $.Release.Name }}-extensions-cache.{{ $.Release.Namespace }}%3FsetHttpScheme%3Dtrue&retry=3%3A5{{ end }}"
          {{- else }}
          - name: EXTENSIONS_REPOSITORY_URLS
            value: "{{ range $index, $element := .Values.extensions.repositoryUrls }}{{ if $index }},{{ end }}{{ $element }}{{ end }}"
          {{- end }}
          {{- if .Values.authentication.type }}
          - name: STACKGRES_AUTH_TYPE
            value: "{{ .Values.authentication.type }}"
          {{- end }}
          {{- if eq .Values.authentication.type "oidc" }}
          - name: QUARKUS_OIDC_APPLICATION_TYPE
            value: "web-app"
          - name: QUARKUS_OIDC_PUBLIC_KEY
            value: ""
          {{- if .Values.authentication.oidc.authServerUrl }}
          - name: QUARKUS_OIDC_AUTH_SERVER_URL
            value: "{{ .Values.authentication.oidc.authServerUrl }}"
          {{- end }}
          {{- if .Values.authentication.oidc.tlsVerification }}
          - name: QUARKUS_OIDC_TLS_VERIFICATION
            value: "{{ .Values.authentication.oidc.tlsVerification }}"
          {{- end }}
          {{- if or (.Values.authentication.oidc.clientId) (.Values.authentication.oidc.clientIdSecretRef) }}
          - name: QUARKUS_OIDC_CLIENT_ID
            {{- if and (.Values.authentication.oidc.clientId) (not .Values.authentication.oidc.clientIdSecretRef) }}
            value: "{{ .Values.authentication.oidc.clientId }}"
            {{- end }}
            {{- if .Values.authentication.oidc.clientIdSecretRef }}
            valueFrom:
              secretKeyRef:
                name: "{{ .Values.authentication.oidc.clientIdSecretRef.name }}"
                key: "{{ .Values.authentication.oidc.clientIdSecretRef.key }}"
            {{- end }}
          {{- end }}
          {{- if or (.Values.authentication.oidc.credentialsSecret) (.Values.authentication.oidc.credentialsSecretSecretRef) }}
          - name: QUARKUS_OIDC_CREDENTIALS_SECRET
            {{- if and (.Values.authentication.oidc.credentialsSecret) (not .Values.authentication.oidc.credentialsSecretSecretRef) }}
            value: "{{ .Values.authentication.oidc.credentialsSecret }}"
            {{- end }}
            {{- if .Values.authentication.oidc.credentialsSecretSecretRef }}
            valueFrom:
              secretKeyRef:
                name: "{{ .Values.authentication.oidc.credentialsSecretSecretRef.name }}"
                key: "{{ .Values.authentication.oidc.credentialsSecretSecretRef.key }}"
            {{- end }}
          {{- end }}
          {{- end }}
        ports:
        - containerPort: 8080
          name: "resthttp"
          protocol: "TCP"
        - containerPort: 8443
          name: "resthttps"
          protocol: "TCP"
        livenessProbe:
          httpGet:
            path: "/q/health/live"
            port: 8080
            scheme: "HTTP"
          initialDelaySeconds: 5
          periodSeconds: 30
          timeoutSeconds: 10
        readinessProbe:
          httpGet:
            path: "/q/health/ready"
            port: 8080
            scheme: "HTTP"
          initialDelaySeconds: 0
          periodSeconds: 2
          timeoutSeconds: 1
        {{- with .Values.restapi.resources }}
        resources:
        {{- toYaml . | nindent 10 }}
        {{- end }}
        volumeMounts:
          - name: web-certs
            mountPath: /etc/operator/certs
            readOnly: true
      - name: {{ .Values.adminui.name }}
        image: "{{ include "adminui-image" . }}"
        imagePullPolicy: {{ .Values.adminui.image.pullPolicy }}
        securityContext:
          {{- if or (not (.Capabilities.APIVersions.Has "project.openshift.io/v1")) .Values.developer.disableArbitraryUser }}
          runAsNonRoot: true
          runAsUser: 998
          runAsGroup: 996
          {{- end }}
        env:
          {{- if and .Values.grafana.url .Values.grafana.token .Values.grafana.webHost }}
          - name: GRAFANA_EMBEDDED
            value: "true"
          - name: GRAFANA_URL_PATH
            value: "{{ regexReplaceAll "^https?://[^/]+(/.*)$" .Values.grafana.url "${1}" }}"
          - name: GRAFANA_SCHEMA
            value: "{{ default "http" .Values.grafana.scheme }}"
          - name: GRAFANA_WEB_HOST
            value: "{{ regexReplaceAll "/" .Values.grafana.webHost "" }}"
          - name: GRAFANA_TOKEN
            value: "{{ .Values.grafana.token }}"
          {{- else }}
          - name: GRAFANA_URL_PATH
            value: "/"
          - name: GRAFANA_SCHEMA
            value: "http"
          - name: GRAFANA_WEB_HOST
            value: "localhost:8080"
          - name: GRAFANA_TOKEN
            value: "unknown"
          {{- end }}
        args:
          - '/bin/sh'
          - '-ec'
          {{- if .Values.developer.showDebug }}
          - '-x'
          {{- end }}
          - |
            {{- if .Values.developer.showDebug }}
            echo "
              GRAFANA_EMBEDDED=$GRAFANA_EMBEDDED
              GRAFANA_URL_PATH=$GRAFANA_URL_PATH
              GRAFANA_SCHEMA=$GRAFANA_SCHEMA
              GRAFANA_WEB_HOST=$GRAFANA_WEB_HOST
              GRAFANA_TOKEN=$GRAFANA_TOKEN"
            {{- end }}
            envsubst '
              $GRAFANA_EMBEDDED
              $GRAFANA_URL_PATH
              $GRAFANA_SCHEMA
              $GRAFANA_WEB_HOST
              $GRAFANA_TOKEN' \
              < /etc/nginx/template.d/stackgres-restapi.template \
              > /etc/nginx/conf.d/stackgres-restapi.conf
            {{- if .Values.developer.showDebug }}
            cat /etc/nginx/conf.d/stackgres-restapi.conf
            {{- end }}
            exec nginx -g 'daemon off;'
        ports:
        - containerPort: 9443
          name: "https"
          protocol: "TCP"
        - containerPort: 9080
          name: "http"
          protocol: "TCP"
        {{- with .Values.adminui.resources }}
        resources:
        {{- toYaml . | nindent 10 }}
        {{- end }}
        volumeMounts:
          - name: web-certs
            mountPath: /etc/operator/certs
            readOnly: true
          - name: operator-nginx
            mountPath: /etc/nginx/nginx.conf
            subPath: nginx.conf
            readOnly: true
          - name: operator-nginx
            mountPath: /etc/nginx/template.d
            readOnly: true
          - name: operator-nginx-etc
            subPath: etc/nginx/conf.d
            mountPath: /etc/nginx/conf.d
            readOnly: false
          - name: operator-nginx-etc
            subPath: var/cache/nginx
            mountPath: /var/cache/nginx
            readOnly: false
          - name: operator-nginx-etc
            subPath: var/run
            mountPath: /var/run
            readOnly: false
      volumes:
        - name: web-certs
          secret:
            secretName: {{ include "web-cert-name" . }}
            optional: false
            items:
              - key: tls.key
                path: root.key
              - key: tls.crt
                path: server.crt
              - key: jwt-rsa.key
                path: jwt-rsa.key
              - key: jwt-rsa.pub
                path: jwt-rsa.pub
        - name: operator-nginx
          configMap:
            name: {{ .Values.restapi.name }}-nginx
            optional: false
            items:
              - key: nginx.conf
                path: nginx.conf
              - key: stackgres-restapi.template
                path: stackgres-restapi.template
        - name: operator-nginx-etc
          emptyDir: {}
      {{- with .Values.restapi.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
{{- end }}
